#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "zap0001three4xi.py">
#<abstract4xi abstract = "zaps to direction three"/>
#<verify4xi verification = "11" target = "zap2actor4xi.py"/>
#<refer4xi reference = "zap2actor4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
 
# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'zap0001three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
ack2dragontrace = False

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "zap0001three4xi" usage = "target function for zap0000three4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def zap0001three4xi(queue2three, consumer_channel2three, publisher_channel2three, kb2three):  
    '''
    returns skeleton to direction three via queue
    '''

    

    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                      
    # -------------------------------------------------------------------------------------------------                                                               
      
    time2start = time4xi()  
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF ZAP0001THREE4XI - STARTED TIME: ", time2start)                                         # 
        print("\n (STEP 1A2/33) OF ZAP0001THREE4XI -  QUEUE2THREE: ", queue2three)                                        # 
        print("\n (STEP 1A3/33) OF ZAP0001THREE4XI -  CONSUME_CHANNEL4THREE: ", consumer_channel2three)                   # 
        print("\n (STEP 1A4/33) OF ZAP0001THREE4XI -  PUBLISHER_CHANNEL4THREE: ", publisher_channel2three)                #     
        # print("\n (STEP 1A5/33) OF ZAP0001THREE4XI -  KB2THREE: ", kb2three)                                              # 


        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    if ack2debug is True:
        print("\n (STEP 2A/33) OF ZAP0001THREE4XI - TRYING TO PUT TO QUEUE2THREE: ", queue2three)                         # 
    
    ack2put = False                                                                                                                           
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SKELETON NODE FOR DIRECTION THREE TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        key2kb = '1x1y-1z'
        kb2put = {}
        kb2put[key2kb] = kb2three[key2kb]
        queue2three.put(kb2put)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF ZAP0001THREE4XI - SUCCEEDED TO PUT TO QUEUE: ", queue2three, " KB2PUT: ", kb2put)   # {'1x1y-1z': {'2xi': {1: 3, 2: 2, 3: {1: 6.283185307179586, 2: '#C3BDB7', 3: 1, 4: 6.283185307179586}, 4: 'dragon1x1y-1z', 5: '#95652E', 6: 3, 7: 33, 8: 1.7325080757, 9: 0.267949192431, 10: 8, 11: '{started; sense-of-3Skeleton4Xi-started: 11:25:22 12/07/10 Pacific Standard Time}', 12: 'sense', 13: 2}, '8xi': {}, '4xi': {}}}

            
        ack2put = True    
    except:
        print("\n (STEP 2D/33) OF ZAP0001THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF ZAP0001THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL4THREE: ", publisher_channel2three)
                                                                                                                    # 
    if ack2put is True:
        message2send4three = "<ack2put4xi>layer02three</ack2put4xi>"
    else:
        message2send4three = "<nack2put4xi>layer02three</nack2put4xi>" 
                     
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:     
            print(" (STEP 3B/33) OF ZAP0001THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
                                                                                                                    # <ack2put4xi>layer02three</ack2put4xi>  TO PUBLISHER_CHANNEL2THREE:  <read-write PipeConnection, handle 264>
    except:
        print(" (STEP 3C/33) OF ZAP0001THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF ZAP0001THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
                                                                                                                    # 
          
    return queue2three    
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_zap2actor4xi.txt
#   scope-sense*4xi.xml
#   sense-test-zap2actor4xi.xml
#   reason-test-zap2actor4xi.xml
#   ace-test-zap2actor4xi4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of zap0001three4xi.py                          
# ------------------------------------------------------------------------------------------------- 
#"
#/>
